(define-module(ice-9 format)#:export(format format:symbol-case-conv format:iobj-case-conv format:expch)#:autoload(ice-9 pretty-print)(pretty-print))
(define format:symbol-case-conv #f)
(define format:iobj-case-conv #f)
(define format:expch #\E)
(define format:floats(provided?  'inexact))
(define format:complex-numbers(provided?  'complex))
(define format:radix-pref(char=? #\#(string-ref(number->string 8 8)0)))
(define =version "3.1")
(define =ascii-non-printable-charnames  '#("nul" "soh" "stx" "etx" "eot" "enq" "ack" "bel" "bs" "ht" "nl" "vt" "np" "cr" "so" "si" "dle" "dc1" "dc2" "dc3" "dc4" "nak" "syn" "etb" "can" "em" "sub" "esc" "fs" "gs" "rs" "us" "space"))
(define =parameter-characters '(#\0 #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9 #\- #\+ #\v #\# #\'))
(define =space-ch(char->integer #\space))
(define =zero-ch(char->integer #\0))
(define =roman-alist '((1000 . "M") (500 . "D") (100 . "C") (50 . "L") (10 . "X") (5 . "V") (1 . "I")))
(define =cardinal-tens #(#f #f "twenty" "thirty" "forty" "fifty" "sixty" "seventy" "eighty" "ninety"))
(define =fn-max 200)
(define =en-max 10)
(define subs make-shared-substring)
(define (format . args)(let((f:args(cond((null? args)(error "not enough arguments"))((string?(car args))(cons #f args))(else args)))(oport #f)(ocol 0)(flush-output? #f)(case-conversion #f)(error-continuation #f)(f:pos 0)(f:arg-pos 0)(error-save #f)(read-proof? #f)(fn-str #f)(fn-len 0)(fn-dot #f)(fn-pos? #t)(en-str #f)(en-len 0)(en-pos? #t))(define(o!str str)(display(if case-conversion(case-conversion str)str)oport)(set! ocol(+ ocol(string-length str))))(define (o!strs . strings)(for-each o!str strings))(define(o!char ch)(if case-conversion(display(case-conversion(string ch))oport)(write-char ch oport))(set! ocol(if(char=? ch #\newline)0(+ ocol 1))))(define(o!substr str beg end)(o!str(subs str beg end)))(define(o!fill n ch)(do((i 0(+ i 1)))((= i n))(write-char ch oport))(set! ocol(+ ocol n)))(define (bad! . args)(let((prev-ec error-continuation)(format-args f:args)(port(current-error-port)))(set! bad! dire!)(if(and(>=(length f:args)2)(string?(cadr f:args)))(let((format-string(cadr format-args)))(or(zero? f:arg-pos)(set! f:arg-pos(- f:arg-pos 1)))(format port "~%F: error with call: (format ~A \"~A<===~A\" ~\n                                  ~{~A ~}===>~{~A ~})~%        "(car f:args)(subs format-string 0 f:pos)(subs format-string f:pos(string-length format-string))(list-head(cddr f:args)f:arg-pos)(list-tail(cddr f:args)f:arg-pos)))(format port "~%F: error with call: (format~{ ~A~})~%        " f:args))(apply format port args)(newline port)(set! bad! error-save)(set! error-continuation prev-ec)(die!)(dire! "die! does not jump to toplevel!")))(define (dire! . args)(display "FORMAT INTERNAL ERROR!!")(newline)(display "        format args: ")(write f:args)(newline)(display "        error args:  ")(write args)(newline)(set! bad! error-save)(die!))(define(work format-string arglist)(let((format-string-len(string-length format-string))(arg-pos 0)(arg-len(length arglist))(modifier #f)(params '())(param-value-found #f)(conditional-nest 0)(clause-pos 0)(clause-default #f)(clauses '())(conditional-type #f)(conditional-arg #f)(iteration-nest 0)(iteration-pos 0)(iteration-type #f)(max-iterations #f)(recursive-pos-save f:pos))(define(next-char)(let((ch(peek-next-char)))(set! f:pos(+ 1 f:pos))ch))(define(peek-next-char)(if(>= f:pos format-string-len)(bad! "illegal format string")(string-ref format-string f:pos)))(define(one-positive-integer? params)(cond((null? params)#f)((and(integer?(car params))(>=(car params)0)(=(length params)1))#t)(else(bad! "one positive integer parameter expected"))))(define(next-arg)(and(>= arg-pos arg-len)(begin(set! f:arg-pos(+ arg-len 1))(bad! "missing argument(s)")))(add-arg-pos 1)(list-ref arglist(- arg-pos 1)))(define(prev-arg)(add-arg-pos -1)(and(negative? arg-pos)(bad! "missing backward argument(s)"))(list-ref arglist arg-pos))(define(rest-args)(let loop((l arglist)(k arg-pos))(if(zero? k)l(loop(cdr l)(- k 1)))))(define(add-arg-pos n)(set! arg-pos(+ n arg-pos))(set! f:arg-pos arg-pos))(define(anychar-dispatch)(if(>= f:pos format-string-len)arg-pos(let((char(next-char)))(cond((char=? char #\~)(set! modifier #f)(set! params '())(set! param-value-found #f)(tilde-dispatch))(else(and(zero? conditional-nest)(zero? iteration-nest)(o!char char))(anychar-dispatch))))))(define(tilde-dispatch)(cond((>= f:pos format-string-len)(o!str "~")arg-pos)((and(or(zero? conditional-nest)(memv(peek-next-char)(append '(#\[ #\] #\; #\: #\@ #\^)=parameter-characters)))(or(zero? iteration-nest)(memv(peek-next-char)(append '(#\{ #\} #\: #\@ #\^)=parameter-characters))))(case(char-upcase(next-char))((#\A)(set! read-proof?(memq modifier '(colon colon-at)))(o!obj-padded(memq modifier '(at colon-at))(next-arg)#f params)(anychar-dispatch))((#\S)(set! read-proof?(memq modifier '(colon colon-at)))(o!obj-padded(memq modifier '(at colon-at))(next-arg)#t params)(anychar-dispatch))((#\D)(o!num-padded modifier(next-arg)params 10)(anychar-dispatch))((#\X)(o!num-padded modifier(next-arg)params 16)(anychar-dispatch))((#\O)(o!num-padded modifier(next-arg)params 8)(anychar-dispatch))((#\B)(o!num-padded modifier(next-arg)params 2)(anychar-dispatch))((#\R)(if(null? params)((case modifier((at)o!num-roman)((colon-at)o!num-old-roman)((colon)o!num-ordinal)(else o!num-cardinal))(next-arg))(o!num-padded modifier(next-arg)(cdr params)(car params)))(anychar-dispatch))((#\F)(if format:floats(o!fixed modifier(next-arg)params)(o!str(number->string(next-arg))))(anychar-dispatch))((#\E)(if format:floats(o!expon modifier(next-arg)params)(o!str(number->string(next-arg))))(anychar-dispatch))((#\G)(if format:floats(o!general modifier(next-arg)params)(o!str(number->string(next-arg))))(anychar-dispatch))((#\$)(if format:floats(o!dollar modifier(next-arg)params)(o!str(number->string(next-arg))))(anychar-dispatch))((#\I)(or format:complex-numbers(bad! "complex numbers not supported by this scheme system"))(let((z(next-arg)))(or(complex? z)(bad! "argument not a complex number"))(o!fixed modifier(real-part z)params)(o!fixed  'at(imag-part z)params)(o!char #\i))(anychar-dispatch))((#\C)(let((ch(if(one-positive-integer? params)(integer->char(car params))(next-arg))))(or(char? ch)(bad! "~~C expects a character"))(case modifier((at)(o!str(str<-char ch)))((colon)(let((c(char->integer ch)))(and(< c 0)(set! c(+ c 256)))(cond((< c 32)(o!char #\^)(o!char(integer->char(+ c 64))))((>= c 127)(o!strs "#\\"(if format:radix-pref(let((s(number->string c 8)))(subs s 2(string-length s)))(number->string c 8))))(else(o!char ch)))))(else(o!char ch))))(anychar-dispatch))((#\P)(and(memq modifier '(colon colon-at))(prev-arg))(let((arg(next-arg)))(or(number? arg)(bad! "~~P expects a number argument"))(if(= arg 1)(and(memq modifier '(at colon-at))(o!char #\y))(if(memq modifier '(at colon-at))(o!str "ies")(o!char #\s))))(anychar-dispatch))((#\~)(if(one-positive-integer? params)(o!fill(car params)#\~)(o!char #\~))(anychar-dispatch))((#\%)(if(one-positive-integer? params)(o!fill(car params)#\newline)(o!char #\newline))(set! ocol 0)(anychar-dispatch))((#\&)(if(one-positive-integer? params)(begin(and(>(car params)0)(o!fill(-(car params)(if(> ocol 0)0 1))#\newline))(set! ocol 0))(and(> ocol 0)(o!char #\newline)))(anychar-dispatch))((#\_)(if(one-positive-integer? params)(o!fill(car params)#\space)(o!char #\space))(anychar-dispatch))((#\/)(if(one-positive-integer? params)(o!fill(car params)#\ht)(o!char #\ht))(anychar-dispatch))((#\|)(if(one-positive-integer? params)(o!fill(car params)#\np)(o!char #\np))(set! ocol 0)(anychar-dispatch))((#\T)(tabulate modifier params)(anychar-dispatch))((#\Y)(pretty-print(next-arg)oport)(set! ocol 0)(anychar-dispatch))((#\? #\K)(cond((memq modifier '(colon colon-at))(bad! "illegal modifier in ~~?"))((eq? modifier  'at)(let*((frmt(next-arg))(args(rest-args)))(add-arg-pos(work frmt args))))(else(let*((frmt(next-arg))(args(next-arg)))(work frmt args))))(anychar-dispatch))((#\!)(set! flush-output? #t)(anychar-dispatch))((#\newline)(and(eq? modifier  'at)(o!char #\newline))(and(< f:pos format-string-len)(do((ch(peek-next-char)(peek-next-char)))((or(not(char-whitespace? ch))(= f:pos(- format-string-len 1))))(if(eq? modifier  'colon)(o!char(next-char))(next-char))))(anychar-dispatch))((#\*)(case modifier((colon)(if(one-positive-integer? params)(do((i 0(+ i 1)))((= i(car params)))(prev-arg))(prev-arg)))((at)(set! arg-pos(if(one-positive-integer? params)(car params)0)))((colon-at)(bad! "illegal modifier `:@' in ~~* directive"))(else(if(one-positive-integer? params)(do((i 0(+ i 1)))((= i(car params)))(next-arg))(next-arg))))(anychar-dispatch))((#\()(set! case-conversion(case modifier((at)string-capitalize-first)((colon)string-capitalize)((colon-at)string-upcase)(else string-downcase)))(anychar-dispatch))((#\))(or case-conversion(bad! "missing ~~("))(set! case-conversion #f)(anychar-dispatch))((#\[)(set! conditional-nest(+ conditional-nest 1))(cond((= conditional-nest 1)(set! clause-pos f:pos)(set! clause-default #f)(set! clauses '())(set! conditional-type(case modifier((at) 'if-then)((colon) 'if-else-then)((colon-at)(bad! "illegal modifier in ~~["))(else  'num-case)))(set! conditional-arg(if(one-positive-integer? params)(car params)(next-arg)))))(anychar-dispatch))((#\;)(and(zero? conditional-nest)(bad! "~~; not in ~~[~~] conditional"))(or(null? params)(bad! "no parameter allowed in ~~;"))(and(= conditional-nest 1)(let((clause-str(cond((eq? modifier  'colon)(set! clause-default #t)(subs format-string clause-pos(- f:pos 3)))((memq modifier '(at colon-at))(bad! "illegal modifier in ~~;"))(else(subs format-string clause-pos(- f:pos 2))))))(set! clauses(append clauses(list clause-str)))(set! clause-pos f:pos)))(anychar-dispatch))((#\])(and(zero? conditional-nest)(bad! "missing ~~["))(set! conditional-nest(- conditional-nest 1))(and modifier(bad! "no modifier allowed in ~~]"))(or(null? params)(bad! "no parameter allowed in ~~]"))(cond((zero? conditional-nest)(let((clause-str(subs format-string clause-pos(- f:pos 2))))(if clause-default(set! clause-default clause-str)(set! clauses(append clauses(list clause-str)))))(case conditional-type((if-then)(and conditional-arg(work(car clauses)(list conditional-arg))))((if-else-then)(add-arg-pos(work(if conditional-arg(cadr clauses)(car clauses))(rest-args))))((num-case)(and(or(not(integer? conditional-arg))(< conditional-arg 0))(bad! "argument not a positive integer"))(or(and(>= conditional-arg(length clauses))(not clause-default))(add-arg-pos(work(if(>= conditional-arg(length clauses))clause-default(list-ref clauses conditional-arg))(rest-args))))))))(anychar-dispatch))((#\{)(set! iteration-nest(+ iteration-nest 1))(cond((= iteration-nest 1)(set! iteration-pos f:pos)(set! iteration-type(case modifier((at) 'rest-args)((colon) 'sublists)((colon-at) 'rest-sublists)(else  'list)))(set! max-iterations(and(one-positive-integer? params)(car params)))))(anychar-dispatch))((#\})(and(zero? iteration-nest)(bad! "missing ~~{"))(set! iteration-nest(- iteration-nest 1))(case modifier((colon)(or max-iterations(set! max-iterations 1)))((colon-at at)(bad! "illegal modifier")))(or(null? params)(bad! "no parameters allowed in ~~}"))(and(zero? iteration-nest)(let((iteration-str(subs format-string iteration-pos(- f:pos(if modifier 3 2)))))(and(string=? iteration-str "")(set! iteration-str(next-arg)))(case iteration-type((list)(let((args(next-arg))(args-len 0))(or(list? args)(bad! "expected a list argument"))(set! args-len(length args))(do((arg-pos 0(+ arg-pos(work iteration-str(list-tail args arg-pos))))(i 0(+ i 1)))((or(>= arg-pos args-len)(and max-iterations(>= i max-iterations)))))))((sublists)(let((args(next-arg))(args-len 0))(or(list? args)(bad! "expected a list argument"))(set! args-len(length args))(do((arg-pos 0(+ arg-pos 1)))((or(>= arg-pos args-len)(and max-iterations(>= arg-pos max-iterations))))(let((sublist(list-ref args arg-pos)))(or(list? sublist)(bad! "expected a list of lists argument"))(work iteration-str sublist)))))((rest-args)(let*((args(rest-args))(args-len(length args))(usedup-args(do((arg-pos 0(+ arg-pos(work iteration-str(list-tail args arg-pos))))(i 0(+ i 1)))((or(>= arg-pos args-len)(and max-iterations(>= i max-iterations)))arg-pos))))(add-arg-pos usedup-args)))((rest-sublists)(let*((args(rest-args))(args-len(length args))(usedup-args(do((arg-pos 0(+ arg-pos 1)))((or(>= arg-pos args-len)(and max-iterations(>= arg-pos max-iterations)))arg-pos)(let((sublist(list-ref args arg-pos)))(or(list? sublist)(bad! "expected list arguments"))(work iteration-str sublist)))))(add-arg-pos usedup-args)))(else(bad! "internal error in ~~}")))))(anychar-dispatch))((#\^)(and(cond((not(null? params))(not(case(length params)((1)(zero?(car params)))((2)(=(list-ref params 0)(list-ref params 1)))((3)(<=(list-ref params 0)(list-ref params 1)(list-ref params 2)))(else(bad! "too much parameters")))))(case-conversion(set! case-conversion string-copy)#t)((= iteration-nest 1)#t)((= conditional-nest 1)#t)((>= arg-pos arg-len)(set! f:pos format-string-len)#f)(else #t))(anychar-dispatch)))((#\@)(and(memq modifier '(at colon-at))(bad! "double `@' modifier"))(set! modifier(if(eq? modifier  'colon) 'colon-at  'at))(tilde-dispatch))((#\:)(and(memq modifier '(colon colon-at))(bad! "double `:' modifier"))(set! modifier(if(eq? modifier  'at) 'colon-at  'colon))(tilde-dispatch))((#\')(and modifier(bad! "misplaced modifier"))(set! params(append params(list(char->integer(next-char)))))(set! param-value-found #t)(tilde-dispatch))((#\0 #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9 #\- #\+)(and modifier(bad! "misplaced modifier"))(let((num-str-beg(- f:pos 1))(num-str-end f:pos))(do((ch(peek-next-char)(peek-next-char)))((not(char-numeric? ch)))(next-char)(set! num-str-end(+ 1 num-str-end)))(set! params(append params(list(string->number(subs format-string num-str-beg num-str-end))))))(set! param-value-found #t)(tilde-dispatch))((#\V)(and modifier(bad! "misplaced modifier"))(set! params(append params(list(next-arg))))(set! param-value-found #t)(tilde-dispatch))((#\#)(and modifier(bad! "misplaced modifier"))(set! params(append params(list(length(rest-args)))))(set! param-value-found #t)(tilde-dispatch))((#\,)(and modifier(bad! "misplaced modifier"))(or param-value-found(set! params(append params '(#f))))(set! param-value-found #f)(tilde-dispatch))((#\Q)(if(eq? modifier  'colon)(o!str =version)(let((nl(string #\newline)))(o!strs "(ice-9 format) version " =version nl "  (C) Copyright 2007 Thien-Thi Nguyen" nl)(set! ocol 0)))(anychar-dispatch))(else(bad! "unknown control character `~C'"(string-ref format-string(- f:pos 1))))))(else(anychar-dispatch))))(set! f:pos 0)(set! f:arg-pos 0)(anychar-dispatch)(set! f:pos recursive-pos-save)arg-pos))(define(str<-obj obj slashify)(define(obj->str obj slashify visited)(if(memq obj(cdr visited))(let((n(-(list-index(cdr visited)(cdr obj)))))(string-append "#"(number->string n)"#"))(cond((string? obj)(if slashify(let((obj-len(string-length obj)))(string-append "\""(let loop((i 0)(j 0))(if(= j obj-len)(string-append(subs obj i j)"\"")(let((c(string-ref obj j)))(if(or(char=? c #\\)(char=? c #\"))(string-append(subs obj i j)"\\"(loop j(+ j 1)))(loop i(+ j 1))))))))obj))((boolean? obj)(if obj "#t" "#f"))((number? obj)(number->string obj))((symbol? obj)(if format:symbol-case-conv(format:symbol-case-conv(symbol->string obj))(symbol->string obj)))((char? obj)(if slashify(str<-char obj)(string obj)))((null? obj)"()")((input-port? obj)(str<-iobj obj))((output-port? obj)(str<-iobj obj))((pair? obj)(string-append "("(let loop((obj-list obj)(visited visited)(offset 0)(prefix ""))(cond((null?(cdr obj-list))(string-append prefix(obj->str(car obj-list)#t(cons(car obj-list)visited))))((memq(cdr obj-list)visited)(string-append prefix(obj->str(car obj-list)#t(cons(car obj-list)visited))" . #"(number->string(- offset(list-index visited(cdr obj-list))))"#"))((pair?(cdr obj-list))(loop(cdr obj-list)(cons(cdr obj-list)visited)(+ 1 offset)(string-append prefix(obj->str(car obj-list)#t(cons(car obj-list)visited))" ")))(else(string-append prefix(obj->str(car obj-list)#t(cons(car obj-list)visited))" . "(obj->str(cdr obj-list)#t(cons(cdr obj-list)visited))))))")"))((vector? obj)(string-append "#"(obj->str(vector->list obj)#t visited)))(else(str<-iobj obj)))))(obj->str obj slashify(list obj)))(define(str<-iobj iobj)(let((s(call-with-output-string(lambda(p)(display iobj p)))))(if(or read-proof? format:iobj-case-conv)(string-append(if read-proof? "\"" "")(if format:iobj-case-conv(format:iobj-case-conv s)s)(if read-proof? "\"" ""))s)))(define(str<-char ch)(let((int-rep(modulo(char->integer ch)256)))(string-append "#\\"(cond((char=? ch #\newline)"newline")((and(>= int-rep 0)(<= int-rep 32))(vector-ref =ascii-non-printable-charnames int-rep))((= int-rep 127)"del")((>= int-rep 128)(if format:radix-pref(let((s(number->string int-rep 8)))(subs s 2(string-length s)))(number->string int-rep 8)))(else(string ch))))))(define(xpar pars length index default name)(if(> length index)(let((par(list-ref pars index)))(if par(if name(if(< par 0)(bad! "~S parameter must be a positive integer" name)par)par)default))default))(define(o!obj-padded pad-left obj slashify pars)(if(null? pars)(o!str(str<-obj obj slashify))(let((l(length pars)))(let((mincol(xpar pars l 0 0 "mincol"))(colinc(xpar pars l 1 1 "colinc"))(minpad(xpar pars l 2 0 "minpad"))(padchar(integer->char(xpar pars l 3 =space-ch #f)))(objstr(str<-obj obj slashify)))(or pad-left(o!str objstr))(do((objstr-len(string-length objstr))(i minpad(+ i colinc)))((>=(+ objstr-len i)mincol)(o!fill i padchar)))(and pad-left(o!str objstr))))))(define(o!num-padded modifier number pars radix)(or(integer? number)(bad! "argument not an integer"))(let((numstr(number->string number radix)))(and format:radix-pref(not(= radix 10))(set! numstr(subs numstr 2(string-length numstr))))(if(and(null? pars)(not modifier))(o!str numstr)(let((l(length pars))(numstr-len(string-length numstr)))(let((mincol(xpar pars l 0 #f "mincol"))(padchar(integer->char(xpar pars l 1 =space-ch #f)))(commachar(integer->char(xpar pars l 2(char->integer #\,)#f)))(commawidth(xpar pars l 3 3 "commawidth")))(and mincol(let((numlen numstr-len))(and(memq modifier '(at colon-at))(> number 0)(set! numlen(+ numlen 1)))(and(memq modifier '(colon colon-at))(set! numlen(+(quotient(- numstr-len(if(< number 0)2 1))commawidth)numlen)))(and(> mincol numlen)(o!fill(- mincol numlen)padchar))))(and(memq modifier '(at colon-at))(>= number 0)(o!char #\+))(if(memq modifier '(colon colon-at))(let((start(remainder numstr-len commawidth))(ns(if(< number 0)1 0)))(o!substr numstr 0 start)(do((i start(+ i commawidth)))((>= i numstr-len))(and(> i ns)(o!char commachar))(o!substr numstr i(+ i commawidth))))(o!str numstr)))))))(define(tabulate modifier pars)(let((l(length pars)))(let((colnum(xpar pars l 0 1 "colnum"))(colinc(xpar pars l 1 1 "colinc"))(padch(integer->char(xpar pars l 2 =space-ch #f))))(case modifier((colon colon-at)(bad! "unsupported modifier for ~~T"))((at)(o!fill(if(zero? colinc)colnum(do((c 0(+ c colinc))(col(+ ocol colnum)))((>= c col)(- c ocol))))padch))(else(o!fill(cond((< ocol colnum)(- colnum ocol))((zero? colinc)0)(else(do((c colnum(+ c colinc)))((>= c ocol)(- c ocol)))))padch))))))(define(check-posint n)(or(and(integer? n)(positive? n))(bad! "only positive integers can be romanized")))(define(o!num-old-roman n)(check-posint n)(let loop((n n)(romans =roman-alist))(or(null? romans)(let((roman-val(caar romans))(roman-dgt(cdar romans)))(do((q(quotient n roman-val)(- q 1)))((zero? q)(loop(remainder n roman-val)(cdr romans)))(o!str roman-dgt))))))(define(o!num-roman n)(check-posint n)(let loop((n n)(romans =roman-alist)(boundaries '(100 100 10 10 1 1 #f)))(or(null? romans)(let((roman-val(caar romans))(roman-dgt(cdar romans))(bdry(car boundaries)))(let loop2((q(quotient n roman-val))(r(remainder n roman-val)))(cond((not(zero? q))(o!str roman-dgt)(loop2(- q 1)r))((and bdry(>= r(- roman-val bdry)))(o!strs(assv-ref romans bdry)roman-dgt)(loop(remainder r bdry)(cdr romans)(cdr boundaries)))(else(loop r(cdr romans)(cdr boundaries)))))))))(define(check-int n type)(or(integer? n)(bad! "only integers can be converted to English ~A" type)))(define(o!num-cardinal n)(check-int n "cardinals")(cond((zero? n)(o!str "zero"))((< n 0)(o!str "minus ")(o!num-cardinal(- n)))(else(let*((=ones #(#f "one" "two" "three" "four" "five" "six" "seven" "eight" "nine" "ten" "eleven" "twelve" "thirteen" "fourteen" "fifteen" "sixteen" "seventeen" "eighteen" "nineteen"))(=thousands #("" " thousand" " million" " billion" " trillion" " quadrillion" " quintillion" " sextillion" " septillion" " octillion" " nonillion" " decillion" " undecillion" " duodecillion" " tredecillion" " quattuordecillion" " quindecillion" " sexdecillion" " septendecillion" " octodecillion" " novemdecillion" " vigintillion"))(power3-word-limit(vector-length =thousands)))(let loop((n n)(power3 0)(blocks '()))(if(positive? n)(let((n-before-block(quotient n 1000))(n-after-block(remainder n 1000)))(loop n-before-block(+ power3 1)(if(positive? n-after-block)(acons n-after-block power3 blocks)blocks)))(let spew((blocks blocks))(or(null? blocks)(let*((head(car blocks))(tail(cdr blocks))(pow(cdr head))(n(car head))(hundreds(quotient n 100))(tens+ones(remainder n 100)))(cond((positive? hundreds)(o!strs(vector-ref =ones hundreds)" hundred")(and(positive? tens+ones)(o!str " "))))(if(< tens+ones 20)(and(positive? tens+ones)(o!str(vector-ref =ones tens+ones)))(let((tens(quotient tens+ones 10))(ones(remainder tens+ones 10)))(o!str(vector-ref =cardinal-tens tens))(and(positive? ones)(o!strs "-"(vector-ref =ones ones)))))(if(< pow power3-word-limit)(o!str(vector-ref =thousands pow))(o!strs " times ten to the "(number->string(* 3 pow))" power"))(or(null? tail)(o!str ", "))(spew tail))))))))))(define(o!num-ordinal n)(check-int n "ordinals")(cond((zero? n)(o!str "zeroth"))((< n 0)(o!str "minus ")(o!num-ordinal(- n)))(else(let((=ones #(#f "first" "second" "third" "fourth" "fifth" "sixth" "seventh" "eighth" "ninth" "tenth" "eleventh" "twelfth" "thirteenth" "fourteenth" "fifteenth" "sixteenth" "seventeenth" "eighteenth" "nineteenth"))(=tens #(#f #f "twentieth" "thirtieth" "fortieth" "fiftieth" "sixtieth" "seventieth" "eightieth" "ninetieth"))(hundreds(quotient n 100))(tens+ones(remainder n 100)))(cond((positive? hundreds)(o!num-cardinal(* hundreds 100))(o!str(if(zero? tens+ones)"th" " "))))(or(zero? tens+ones)(if(< tens+ones 20)(o!str(vector-ref =ones tens+ones))(let((tens(quotient tens+ones 10))(ones(remainder tens+ones 10)))(if(zero? ones)(o!str(vector-ref =tens tens))(o!strs(vector-ref =cardinal-tens tens)"-"(vector-ref =ones ones))))))))))(define(o!fixed modifier number pars)(or(number? number)(string? number)(bad! "argument is not a number or a number string"))(let((l(length pars)))(let((width(xpar pars l 0 #f "width"))(digits(xpar pars l 1 #f "digits"))(scale(xpar pars l 2 0 #f))(overch(xpar pars l 3 #f #f))(padch(xpar pars l 4 =space-ch #f)))(if digits(begin(parse-float(if(string? number)number(number->string number))#t scale)(if(<=(- fn-len fn-dot)digits)(fn-zfill #f(- digits(- fn-len fn-dot)))(fn-round digits))(if width(let((numlen(+ fn-len 1)))(and(or(not fn-pos?)(eq? modifier  'at))(set! numlen(+ numlen 1)))(and(zero? fn-dot)(> width(+ digits 1))(set! numlen(+ numlen 1)))(and(< numlen width)(o!fill(- width numlen)(integer->char padch)))(if(and overch(> numlen width))(o!fill width(integer->char overch))(o!fn modifier(> width(+ digits 1)))))(o!fn modifier #t)))(begin(parse-float(if(string? number)number(number->string number))#t scale)(fn-strip)(if width(let((numlen(+ fn-len 1)))(and(or(not fn-pos?)(eq? modifier  'at))(set! numlen(+ numlen 1)))(and(zero? fn-dot)(set! numlen(+ numlen 1)))(and(< numlen width)(o!fill(- width numlen)(integer->char padch)))(if(> numlen width)(let((dot-index(- numlen(- fn-len fn-dot))))(if(> dot-index width)(if overch(o!fill width(integer->char overch))(o!fn modifier #t))(begin(fn-round(- width dot-index))(o!fn modifier #t))))(o!fn modifier #t)))(o!fn modifier #t)))))))(define(o!expon modifier number pars)(or(number? number)(string? number)(bad! "argument is not a number"))(let((l(length pars)))(let((width(xpar pars l 0 #f "width"))(digits(xpar pars l 1 #f "digits"))(edigits(xpar pars l 2 #f "exponent digits"))(scale(xpar pars l 3 1 #f))(overch(xpar pars l 4 #f #f))(padch(xpar pars l 5 =space-ch #f))(expch(xpar pars l 6 #f #f)))(if digits(let((digits(if(> scale 0)(if(< scale(+ digits 2))(+(- digits scale)1)0)digits)))(parse-float(if(string? number)number(number->string number))#f scale)(if(<=(- fn-len fn-dot)digits)(fn-zfill #f(- digits(- fn-len fn-dot)))(fn-round digits))(if width(if(and edigits overch(> en-len edigits))(o!fill width(integer->char overch))(let((numlen(+ fn-len 3)))(and(or(not fn-pos?)(eq? modifier  'at))(set! numlen(+ numlen 1)))(and(zero? fn-dot)(> width(+ digits 1))(set! numlen(+ numlen 1)))(set! numlen(+ numlen(if(and edigits(>= edigits en-len))edigits en-len)))(and(< numlen width)(o!fill(- width numlen)(integer->char padch)))(if(and overch(> numlen width))(o!fill width(integer->char overch))(begin(o!fn modifier(> width(- numlen 1)))(o!en edigits expch)))))(begin(o!fn modifier #t)(o!en edigits expch))))(begin(parse-float(if(string? number)number(number->string number))#f scale)(fn-strip)(if width(if(and edigits overch(> en-len edigits))(o!fill width(integer->char overch))(let((numlen(+ fn-len 3)))(and(or(not fn-pos?)(eq? modifier  'at))(set! numlen(+ numlen 1)))(and(zero? fn-dot)(set! numlen(+ numlen 1)))(set! numlen(+ numlen(if(and edigits(>= edigits en-len))edigits en-len)))(and(< numlen width)(o!fill(- width numlen)(integer->char padch)))(if(> numlen width)(let((f(- fn-len fn-dot)))(if(>(- numlen f)width)(if overch(o!fill width(integer->char overch))(begin(o!fn modifier #t)(o!en edigits expch)))(begin(fn-round(+(- f numlen)width))(o!fn modifier #t)(o!en edigits expch))))(begin(o!fn modifier #t)(o!en edigits expch)))))(begin(o!fn modifier #t)(o!en edigits expch))))))))(define(o!general modifier number pars)(or(number? number)(string? number)(bad! "argument is not a number or a number string"))(let((l(length pars)))(let((width(if(> l 0)(list-ref pars 0)#f))(digits(if(> l 1)(list-ref pars 1)#f))(edigits(if(> l 2)(list-ref pars 2)#f))(overch(if(> l 4)(list-ref pars 4)#f))(padch(if(> l 5)(list-ref pars 5)#f)))(parse-float(if(string? number)number(number->string number))#t 0)(fn-strip)(let*((ee(if edigits(+ edigits 2)4))(ww(if width(- width ee)#f))(n(if(zero? fn-dot)(-(do((i 0(+ i 1)))((or(= i fn-len)(not(char=?(string-ref fn-str i)#\0)))(if(= i fn-len)0 i))))fn-dot))(d(if digits digits(max fn-len(min n 7))))(dd(- d n)))(if(<= 0 dd d)(begin(o!fixed modifier number(list ww dd #f overch padch))(o!fill ee #\space))(o!expon modifier number pars))))))(define(o!dollar modifier number pars)(or(number? number)(string? number)(bad! "argument is not a number or a number string"))(let((l(length pars)))(let((digits(xpar pars l 0 2 "digits"))(mindig(xpar pars l 1 1 "mindig"))(width(xpar pars l 2 0 "width"))(padch(xpar pars l 3 =space-ch #f)))(parse-float(if(string? number)number(number->string number))#t 0)(if(<=(- fn-len fn-dot)digits)(fn-zfill #f(- digits(- fn-len fn-dot)))(fn-round digits))(let((numlen(+ fn-len 1)))(and(or(not fn-pos?)(memq modifier '(at colon-at)))(set! numlen(+ numlen 1)))(and mindig(> mindig fn-dot)(set! numlen(+ numlen(- mindig fn-dot))))(and(zero? fn-dot)(not mindig)(set! numlen(+ numlen 1)))(if(< numlen width)(case modifier((colon)(or fn-pos?(o!char #\-))(o!fill(- width numlen)(integer->char padch)))((at)(o!fill(- width numlen)(integer->char padch))(o!char(if fn-pos? #\+ #\-)))((colon-at)(o!char(if fn-pos? #\+ #\-))(o!fill(- width numlen)(integer->char padch)))(else(o!fill(- width numlen)(integer->char padch))(or fn-pos?(o!char #\-))))(if fn-pos?(and(memq modifier '(at colon-at))(o!char #\+))(o!char #\-))))(and mindig(> mindig fn-dot)(o!fill(- mindig fn-dot)#\0))(and(zero? fn-dot)(not mindig)(o!char #\0))(o!substr fn-str 0 fn-dot)(o!char #\.)(o!substr fn-str fn-dot fn-len))))(define(parse-float num-str fixed? scale)(set! fn-pos? #t)(set! fn-len 0)(set! fn-dot #f)(set! en-pos? #t)(set! en-len 0)(do((i 0(+ i 1))(left-zeros 0)(mantissa? #t)(all-zeros? #t)(num-len(string-length num-str))(c #f))((= i num-len)(or fn-dot(set! fn-dot fn-len))(and all-zeros?(begin(set! left-zeros 0)(set! fn-dot 0)(set! fn-len 1)))(if fixed?(begin(and(> left-zeros 0)(> fn-dot 0)(if(> fn-dot left-zeros)(begin(fn-shiftleft left-zeros)(set! fn-dot(- fn-dot left-zeros))(set! left-zeros 0))(begin(fn-shiftleft fn-dot)(set! left-zeros(- left-zeros fn-dot))(set! fn-dot 0))))(and(or(not(zero? scale))(> en-len 0))(let((shift(+ scale(en-int))))(cond(all-zeros? #t)((>(+ fn-dot shift)fn-len)(fn-zfill #f(- shift(- fn-len fn-dot)))(set! fn-dot fn-len))((<(+ fn-dot shift)0)(fn-zfill #t(-(- shift)fn-dot))(set! fn-dot 0))(else(if(> left-zeros 0)(if(<= left-zeros shift)(fn-shiftleft shift)(begin(fn-shiftleft left-zeros)(set! fn-dot(- shift left-zeros))))(set! fn-dot(+ fn-dot shift))))))))(let((negexp(if(> left-zeros 0)(- left-zeros fn-dot -1)(if(zero? fn-dot)1 0))))(if(> left-zeros 0)(begin(fn-shiftleft left-zeros)(set! fn-dot 1))(and(zero? fn-dot)(set! fn-dot 1)))(en-set!(-(+(- fn-dot scale)(en-int))negexp))(cond(all-zeros?(en-set! 0)(set! fn-dot 1))((< scale 0)(fn-zfill #t(- scale))(set! fn-dot 0))((> scale fn-dot)(fn-zfill #f(- scale fn-dot))(set! fn-dot scale))(else(set! fn-dot scale)))))#t)(set! c(string-ref num-str i))(cond((char-numeric? c)(if mantissa?(begin(if(char=? c #\0)(and all-zeros?(set! left-zeros(+ left-zeros 1)))(begin(set! all-zeros? #f)))(string-set! fn-str fn-len c)(set! fn-len(+ fn-len 1)))(begin(string-set! en-str en-len c)(set! en-len(+ en-len 1)))))((or(char=? c #\-)(char=? c #\+))(if mantissa?(set! fn-pos?(char=? c #\+))(set! en-pos?(char=? c #\+))))((char=? c #\.)(set! fn-dot fn-len))((char=? c #\e)(set! mantissa? #f))((char=? c #\E)(set! mantissa? #f))((char-whitespace? c)#t)((char=? c #\d)#t)((char=? c #\#)#t)(else(bad! "illegal character `~C' in number->string" c)))))(define(en-int)(if(zero? en-len)0(do((i 0(+ i 1))(n 0))((= i en-len)(if en-pos? n(- n)))(set! n(+(* n 10)(-(char->integer(string-ref en-str i))=zero-ch))))))(define(en-set! en)(set! en-len 0)(set! en-pos?(>= en 0))(let*((str(number->string en))(len(string-length str))(c #f))(do((i 0(+ i 1)))((= i len))(set! c(string-ref str i))(and(char-numeric? c)(begin(string-set! en-str en-len c)(set! en-len(+ en-len 1)))))))(define(fn-zfill left? n)(and(>(+ n fn-len)=fn-max)(bad! "number is too long to format (enlarge =fn-max)"))(set! fn-len(+ fn-len n))(if left?(do((i fn-len(- i 1)))((< i 0))(string-set! fn-str i(if(< i n)#\0(string-ref fn-str(- i n)))))(do((i(- fn-len n)(+ i 1)))((= i fn-len))(string-set! fn-str i #\0))))(define(fn-shiftleft n)(and(> n fn-len)(bad! "internal error in fn-shiftleft (~D,~D)" n fn-len))(do((i n(+ i 1)))((= i fn-len)(set! fn-len(- fn-len n)))(string-set! fn-str(- i n)(string-ref fn-str i))))(define(fn-round digits)(set! digits(+ digits fn-dot))(do((i digits(- i 1))(c 5))((or(zero? c)(< i 0))(if(= c 1)(begin(set! fn-len digits)(fn-zfill #t 1)(string-set! fn-str 0 #\1)(set! fn-dot(+ fn-dot 1)))(set! fn-len digits)))(set! c(+(-(char->integer(string-ref fn-str i))=zero-ch)c))(string-set! fn-str i(integer->char(if(< c 10)(+ c =zero-ch)(+(- c 10)=zero-ch))))(set! c(if(< c 10)0 1))))(define(o!fn modifier add-leading-zero?)(if fn-pos?(and(eq? modifier  'at)(o!char #\+))(o!char #\-))(if(zero? fn-dot)(and add-leading-zero?(o!char #\0))(o!substr fn-str 0 fn-dot))(o!char #\.)(o!substr fn-str fn-dot fn-len))(define(o!en edigits expch)(o!char(if expch(integer->char expch)format:expch))(o!char(if en-pos? #\+ #\-))(and edigits(< en-len edigits)(o!fill(- edigits en-len)#\0))(o!substr en-str 0 en-len))(define(fn-strip)(string-set! fn-str fn-len #\0)(do((i fn-len(- i 1)))((or(not(char=?(string-ref fn-str i)#\0))(<= i fn-dot))(set! fn-len(+ i 1)))))(define(string-capitalize-first str)(let((cap-str(string-copy str))(non-first-alpha #f)(str-len(string-length str)))(do((i 0(+ i 1)))((= i str-len)cap-str)(let((c(string-ref str i)))(and(char-alphabetic? c)(if non-first-alpha(string-set! cap-str i(char-downcase c))(begin(set! non-first-alpha #t)(string-set! cap-str i(char-upcase c)))))))))(define(die!)(error "error in format"))(set! error-save bad!)(set! fn-str(make-string =fn-max))(set! en-str(make-string =en-max))(set! f:arg-pos 0)(set! f:pos 0)(let((destination(car f:args))(arglist(cdr f:args)))(define(out! port)(set! oport port)(set! case-conversion #f)(set! flush-output? #f)(and=>(port-column port)(lambda(col)(set! ocol col)))(let*((args(cdr arglist))(arg-pos(work(car arglist)args))(arg-len(length args)))(cond((> arg-pos arg-len)(set! f:arg-pos(+ arg-len 1))(display f:arg-pos)(bad! "~A missing argument~:P"(- arg-pos arg-len)))(else(and flush-output?(force-output port))#t))))(if(not destination)(call-with-output-string out!)(out!(cond((eq? #t destination)(current-output-port))((output-port? destination)destination)((number? destination)(current-error-port))(else(bad! "illegal destination `~A'" destination))))))))
(variable-set!(builtin-variable  'format)format)
