(define-module(ice-9 ftw)#:export(ftw nftw))
(define(directory-files dir)(let((dir-stream(opendir dir)))(let loop((new(readdir dir-stream))(acc '()))(if(eof-object? new)(begin(closedir dir-stream)acc)(loop(readdir dir-stream)(if(or(string=? "." new)(string=? ".." new))acc(cons new acc)))))))
(define (pathify . nodes)(let loop((nodes nodes)(result ""))(if(null? nodes)(or(and(string=? "" result)"")(substring result 1(string-length result)))(loop(cdr nodes)(string-append result "/"(car nodes))))))
(define(abs? filename)(char=? #\/(string-ref filename 0)))
(define(visited?-proc size)(let((visited(make-hash-table #:size size)))(lambda(s)(and s(let((ino(stat:ino s)))(or(hash-ref visited ino)(begin(hash-set! visited ino #t)#f)))))))
(define(stat-dir-readable?-proc uid gid)(let((uid(getuid))(gid(getgid)))(lambda(s)(let*((perms(stat:perms s))(perms-bit-set?(lambda(mask)(not(zero?(logand mask perms))))))(or(and(= uid(stat:uid s))(perms-bit-set? 256))(and(= gid(stat:gid s))(perms-bit-set? 32))(perms-bit-set? 4))))))
(define (stat&flag-proc dir-readable? . control-flags)(let*((directory-flag(if(memq  'depth control-flags) 'directory-processed  'directory))(stale-symlink-flag(if(memq  'nftw-style control-flags) 'stale-symlink  'symlink))(physical?(memq  'physical control-flags))(easy-flag(lambda(s)(let((type(stat:type s)))(if(eq?  'directory type)(if(dir-readable? s)directory-flag  'directory-not-readable) 'regular)))))(lambda(name)(let((s(false-if-exception(lstat name))))(cond((not s)(values s  'invalid-stat))((eq?  'symlink(stat:type s))(let((s-follow(false-if-exception(stat name))))(cond((not s-follow)(values s stale-symlink-flag))((and s-follow physical?)(values s  'symlink))((and s-follow(not physical?))(values s-follow(easy-flag s-follow))))))(else(values s(easy-flag s))))))))
(define(clean name)(let((last-char-index(1-(string-length name))))(if(char=? #\/(string-ref name last-char-index))(substring name 0 last-char-index)name)))
(define (ftw filename proc . options)(let*((visited?(visited?-proc(cond((memq  'hash-size options)=> cadr)(else 211))))(stat&flag(stat&flag-proc(stat-dir-readable?-proc(getuid)(getgid)))))(letrec((go(lambda(fullname)(call-with-values(lambda()(stat&flag fullname))(lambda(s flag)(or(visited? s)(let((ret(proc fullname s flag)))(or(eq? #t ret)(throw  'ftw-early-exit ret))(and(eq?  'directory flag)(for-each(lambda(child)(go(pathify fullname child)))(directory-files fullname)))#t)))))))(catch  'ftw-early-exit(lambda()(go(clean filename)))(lambda(key val)val)))))
(define (nftw filename proc . control-flags)(let*((od(getcwd))(odev(let((s(false-if-exception(lstat filename))))(if s(stat:dev s)-1)))(same-dev?(if(memq  'mount control-flags)(lambda(s)(=(stat:dev s)odev))(lambda(s)#t)))(base-sub(lambda(name base)(substring name 0 base)))(maybe-cd(if(memq  'chdir control-flags)(if(abs? filename)(lambda(fullname base dir?)(or(and dir?(chdir fullname))(or(zero? base)(chdir(base-sub fullname base)))))(lambda(fullname base dir?)(chdir(pathify od(if dir? fullname(base-sub fullname base))))))(lambda(fullname base dir?)#t)))(maybe-cd-back(if(memq  'chdir control-flags)(lambda()(chdir od))(lambda()#t)))(depth-first?(memq  'depth control-flags))(visited?(visited?-proc(cond((memq  'hash-size control-flags)=> cadr)(else 211))))(has-kids?(if depth-first?(lambda(flag)(eq? flag  'directory-processed))(lambda(flag)(eq? flag  'directory))))(stat&flag(apply stat&flag-proc(stat-dir-readable?-proc(getuid)(getgid))(cons  'nftw-style control-flags))))(letrec((go(lambda(fullname base level)(call-with-values(lambda()(stat&flag fullname))(lambda(s flag)(letrec((self(lambda()(maybe-cd fullname base(has-kids? flag))(let((ret(proc fullname s flag base level)))(maybe-cd-back)(or(eq? #t ret)(throw  'nftw-early-exit ret)))))(kids(lambda()(and(has-kids? flag)(for-each(lambda(child)(go(pathify fullname child)(1+(string-length fullname))(1+ level)))(directory-files fullname))))))(or(visited? s)(not(same-dev? s))(if depth-first?(begin(kids)(self))(begin(self)(kids)))))))#t)))(let((ret(catch  'nftw-early-exit(lambda()(go(clean filename)0 0))(lambda(key val)val))))(chdir od)ret))))
